CoordSys.h File Reference

Contains utility functions for constructing coordinate systems. More...

`#include <cmath>`
`#include "Types.h"`
`#include "ns.h"`

Go to the source code of this file.

## Namespaces

namespace | detail

## Functions

template<typename T>
FIELD3D_VEC3_T< T > | detail::ceil (const FIELD3D_VEC3_T< T > &v)
| Ceil function for Vec3.
template<typename T>
FIELD3D_MTX_T< T > | coordinateSystem (const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > &wsBounds)
| Constructs a coordinate system given a bounding box.
template<typename T>
FIELD3D_MTX_T< T > | coordinateSystem (const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > &wsBounds, const FIELD3D_VEC3_T< T > &wsVoxelSize)
| Constructs a coordinate system that has its lower left corner at an even multiplier of the voxel-size, to ensure that voxel centers don't shift as the domain grows.
template<typename T>
FIELD3D_MTX_T< T > | coordinateSystem (const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > &wsBounds, const FIELD3D_VEC3_T< T > &wsVoxelSize, Box3i &extents)
| Constructs a coordinate system that has its lower left corner at an even multiplier of the voxel-size, to ensure that voxel centers don't shift as the domain grows.
template<typename T>
FIELD3D_MTX_T< T > | coordinateSystem (const FIELD3D_VEC3_T< T > &e1, const FIELD3D_VEC3_T< T > &e2, const FIELD3D_VEC3_T< T > &e3, const FIELD3D_VEC3_T< T > &origin)
| Constructs a coordinate systems given a set of basis vectors and an origin.
template<typename T>
FIELD3D_NAMESPACE_OPEN FIELD3D_MTX_T< T > | coordinateSystem (const FIELD3D_VEC3_T< T > &e1, const FIELD3D_VEC3_T< T > &e2, const FIELD3D_VEC3_T< T > &e3, const FIELD3D_VEC3_T< T > &origin)
| Constructs a coordinate systems given a set of basis vectors and an origin.
template<typename T>
FIELD3D_VEC3_T< T > | detail::floor (const FIELD3D_VEC3_T< T > &v)
| Floor function for Vec3.

## Detailed Description

Contains utility functions for constructing coordinate systems.

Definition in file CoordSys.h.

## Function Documentation

## coordinateSystem() [1/5]

template<typename T>

FIELD3D_NAMESPACE_OPEN FIELD3D_MTX_T< T > coordinateSystem | ( | const FIELD3D_VEC3_T< T > & | e1,
|  | const FIELD3D_VEC3_T< T > & | e2,
|  | const FIELD3D_VEC3_T< T > & | e3,
|  | const FIELD3D_VEC3_T< T > & | origin )

Constructs a coordinate systems given a set of basis vectors and an origin.

Definition at line 128 of file CoordSys.h.

{
FIELD3D_MTX_T<T> m;
m[0][0] = e1.x;
m[0][1] = e1.y;
m[0][2] = e1.z;
m[1][0] = e2.x;
m[1][1] = e2.y;
m[1][2] = e2.z;
m[2][0] = e3.x;
m[2][1] = e3.y;
m[2][2] = e3.z;
m[3][0] = origin.x;
m[3][1] = origin.y;
m[3][2] = origin.z;
return m;
}
FIELD3D_MTX_T
#define FIELD3D_MTX_T
Definition StdMathLib.h:99

References FIELD3D_MTX_T, and FIELD3D_VEC3_T.

Referenced by detail::adjustedMIPFieldMapping(), coordinateSystem(), coordinateSystem(), and coordinateSystem().

## coordinateSystem() [2/5]

template<typename T>

FIELD3D_MTX_T< T > coordinateSystem | ( | const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > & | wsBounds | ) |

Constructs a coordinate system given a bounding box.

Definition at line 188 of file CoordSys.h.

{
FIELD3D_VEC3_T<T> e1(wsBounds.max.x - wsBounds.min.x, 0, 0);
FIELD3D_VEC3_T<T> e2(0, wsBounds.max.y - wsBounds.min.y, 0);
FIELD3D_VEC3_T<T> e3(0, 0, wsBounds.max.z - wsBounds.min.z);
FIELD3D_VEC3_T<T> origin(wsBounds.min);
return coordinateSystem(e1, e2, e3, origin);
}
coordinateSystem
FIELD3D_NAMESPACE_OPEN FIELD3D_MTX_T< T > coordinateSystem(const FIELD3D_VEC3_T< T > &e1, const FIELD3D_VEC3_T< T > &e2, const FIELD3D_VEC3_T< T > &e3, const FIELD3D_VEC3_T< T > &origin)
Constructs a coordinate systems given a set of basis vectors and an origin.
Definition CoordSys.h:128
FIELD3D_VEC3_T
#define FIELD3D_VEC3_T
Definition SpiMathLib.h:88

References coordinateSystem(), FIELD3D_BOX_T, and FIELD3D_VEC3_T.

## coordinateSystem() [3/5]

template<typename T>

FIELD3D_MTX_T< T > coordinateSystem | ( | const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > & | wsBounds,
|  | const FIELD3D_VEC3_T< T > & | wsVoxelSize,
|  | Box3i & | extents )

Constructs a coordinate system that has its lower left corner at an even multiplier of the voxel-size, to ensure that voxel centers don't shift as the domain grows.

Definition at line 153 of file CoordSys.h.

{
const FIELD3D_VEC3_T<T> voxelMin =
detail::floor<T>(wsBounds.min / wsVoxelSize) * wsVoxelSize;
const FIELD3D_VEC3_T<T> voxelMax =
detail::ceil<T>(wsBounds.max / wsVoxelSize) * wsVoxelSize;
// Resolution
extents.min = V3i(detail::floor<T>(voxelMin / wsVoxelSize) + V3f(0.5));
extents.max = V3i(detail::floor<T>(voxelMax / wsVoxelSize) + V3f(0.5));
// Bounding box
const FIELD3D_BOX_T<FIELD3D_VEC3_T<T> > box(voxelMin, voxelMax);
return coordinateSystem(box);
}
V3i
Imath::V3i V3i
Definition SpiMathLib.h:71
V3f
Imath::V3f V3f
Definition SpiMathLib.h:73
FIELD3D_BOX_T
#define FIELD3D_BOX_T
Definition StdMathLib.h:98
detail::ceil
FIELD3D_VEC3_T< T > ceil(const FIELD3D_VEC3_T< T > &v)
Ceil function for Vec3.
Definition CoordSys.h:114
detail::floor
FIELD3D_VEC3_T< T > floor(const FIELD3D_VEC3_T< T > &v)
Floor function for Vec3.
Definition CoordSys.h:104

References detail::ceil(), coordinateSystem(), FIELD3D_BOX_T, FIELD3D_VEC3_T, and detail::floor().

## coordinateSystem() [4/5]

template<typename T>

FIELD3D_MTX_T< T > coordinateSystem | ( | const FIELD3D_BOX_T< FIELD3D_VEC3_T< T > > & | wsBounds,
|  | const FIELD3D_VEC3_T< T > & | wsVoxelSize )

Constructs a coordinate system that has its lower left corner at an even multiplier of the voxel-size, to ensure that voxel centers don't shift as the domain grows.

Definition at line 176 of file CoordSys.h.

{
Box3i dummy;
return coordinateSystem(wsBounds, wsVoxelSize, dummy);
}
Box3i
Imath::Box3i Box3i
Definition SpiMathLib.h:77

References coordinateSystem(), FIELD3D_BOX_T, and FIELD3D_VEC3_T.

## coordinateSystem() [5/5]

template<typename T>

FIELD3D_MTX_T< T > coordinateSystem | ( | const FIELD3D_VEC3_T< T > & | e1,
|  | const FIELD3D_VEC3_T< T > & | e2,
|  | const FIELD3D_VEC3_T< T > & | e3,
|  | const FIELD3D_VEC3_T< T > & | origin )

Constructs a coordinate systems given a set of basis vectors and an origin.

Definition at line 128 of file CoordSys.h.

{
FIELD3D_MTX_T<T> m;
m[0][0] = e1.x;
m[0][1] = e1.y;
m[0][2] = e1.z;
m[1][0] = e2.x;
m[1][1] = e2.y;
m[1][2] = e2.z;
m[2][0] = e3.x;
m[2][1] = e3.y;
m[2][2] = e3.z;
m[3][0] = origin.x;
m[3][1] = origin.y;
m[3][2] = origin.z;
return m;
}

References FIELD3D_MTX_T, and FIELD3D_VEC3_T.

Referenced by detail::adjustedMIPFieldMapping(), coordinateSystem(), coordinateSystem(), and coordinateSystem().